;; 
;; same as http://curl.haxx.se/lxr/source/docs/examples/simple.c
;;

(use lazy-ffi)

;; OS dependent
(define libcurl (lazy-ffi:open "/usr/local/lib/libcurl.so.3.0"))

;; in "curl/curl.h"
;;  #define CURLOPTTYPE_OBJECTPOINT   10000
;;  #define CINIT(name,type,number) CURLOPT_ ## name = CURLOPTTYPE_ ## type + number
;;  CINIT(URL,  OBJECTPOINT, 2)
(define CURLOPT_URL 10002)

(define (curl_easy_init)
  (lazy-ffi:function libcurl "curl_easy_init" :return :pointer))
(define (curl_easy_setopt curl opt url)
  (lazy-ffi:function libcurl "curl_easy_setopt" :return :int
                     :pointer curl :int opt :string url))
(define (curl_easy_perform curl)
  (lazy-ffi:function libcurl "curl_easy_perform" :return :int
                     :pointer curl))
(define (curl_easy_cleanup curl)
  (lazy-ffi:function libcurl "curl_easy_cleanup" :return :void
                     :pointer curl))

(let ((url "curl.haxx.se")
      (curl (curl_easy_init)))
  (unless (lazy-ffi:null-pointer? curl)
    (begin
      (curl_easy_setopt curl CURLOPT_URL url)
      (curl_easy_perform curl)
      ;; always cleanup
      (curl_easy_cleanup curl))))
